#include <stddef.h>
#include <stdlib.h>

#include <l3tde/map/header.h>
#include <l3tde/util/string.h>

L3TDEMapHeaderPtr
l3tde_map_header_create (const char *name, const size_t name_len,
        const char *description, const size_t description_len) {
    L3TDEMapHeaderPtr self = malloc (sizeof *self);

    self->name = copy_string (name, name_len);
    self->name_len = name_len;

    self->description = copy_string (description, description_len);
    self->description_len = description_len;
    
    return self;
}

void
l3tde_map_header_destroy (L3TDEMapHeaderPtr header) {
    free (header->name);
    free (header->description);

    header->name = NULL;
    header->description = NULL;

    free (header);
}
